多个panic,recover如何写?

taatcc · · 877 次点击 · 开始浏览    置顶
这是一个创建于 的主题,其中的信息可能已经有所发展或是发生改变。
```go package main import ( "fmt" ) func main() { test() } func test() { defer func() { if err := recover(); err != nil { fmt.Println("e1:",err) } }() panic("no1") defer func() { if err := recover(); err != nil { fmt.Println("e2:",err) } }() panic("no2") } ``` 本以为会输出no1、no2,但只输出no1<br> 以为panic("no1")会被第1个recover捕获,然后继续执行panic("no2")<br> 为什么recover会导致退出当前函数?<br> 以上panic是手动panic的,go能否根据一段代码进行判断,然后自动panic?<br>

欢迎关注我们的微信公众号,每天学习Go知识

入群交流(和以上内容无关):加入Go大咖交流群,或添加微信:liuxiaoyan-s 备注:入群;或加QQ群:977810755

877 次点击  
加入收藏 微博
4 回复  |  直到 2019-09-01 18:47:24
暂无回复
添加一条新回复 (您需要 登录 后才能回复 没有账号 ?)
  • 请尽量让自己的回复能够对别人有帮助
  • 支持 Markdown 格式, **粗体**、~~删除线~~、`单行代码`
  • 支持 @ 本站用户;支持表情(输入 : 提示),见 Emoji cheat sheet
  • 图片支持拖拽、截图粘贴等方式上传